<mat-form-field>
  <input
    matInput
    (keyup)="applyFilter($event.target.value)"
    placeholder="Filter"
  />
</mat-form-field>
<table mat-table matSort [dataSource]="dataSource" class="mat-elevation-z8">
  <!--- Note that these columns can be defined in any order.
              The actual rendered columns are set as a property on the row definition" -->

  <!-- Name Column -->
  <ng-container matColumnDef="name">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Name</th>
    <td mat-cell *matCellDef="let element">{{ element.name }}</td>
  </ng-container>

  <!-- Category Column -->
  <ng-container matColumnDef="category">
    <th mat-header-cell *matHeaderCellDef>Category</th>
    <td mat-cell *matCellDef="let element">{{ element.category }}</td>
  </ng-container>

  <!-- Price Column -->
  <ng-container matColumnDef="price">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Price</th>
    <td mat-cell *matCellDef="let element">{{ element.price }}</td>
  </ng-container>

  <!-- CareatedDate Column -->
  <ng-container matColumnDef="createdDate">
    <th mat-header-cell *matHeaderCellDef>Created Date</th>
    <td mat-cell *matCellDef="let element">{{ element.createdDate | date }}</td>
  </ng-container>

  <!-- Delete Button Column -->
  <ng-container matColumnDef="deleteBtn">
    <th mat-header-cell *matHeaderCellDef></th>
    <td mat-cell *matCellDef="let element">
      <button
        mat-raised-button
        color="warn"
        (click)="onDeleteClick($event, element.id)"
      >
        Delete
      </button>
    </td>
  </ng-container>

  <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
  <tr
    mat-row
    *matRowDef="let row; columns: displayedColumns"
    (click)="onProductRowClick(row)"
  ></tr>
</table>
